	.file "c:\\Projects\\private\\cnc_serwo\\example\\commands.c"
	.section	.const,psv
.LC0:
	.asciz	"\015Current Settings:\015\012"
.LC1:
	.asciz	"servo enabled = %d\015\012"
.LC2:
	.asciz	"(p) = %f\015\012"
.LC3:
	.asciz	"(i) = %f\015\012"
.LC4:
	.asciz	"(d) = %f\015\012"
.LC5:
	.asciz	"FF(0) = %f\015\012"
.LC6:
	.asciz	"FF(1) = %f\015\012"
.LC7:
	.asciz	"dead(b)and = %f\015\012"
.LC8:
	.asciz	"(m)ax Output = %f\015\012"
.LC9:
	.asciz	"(f)ault error = %f\015\012"
.LC10:
	.asciz	"(x)pc cmd multiplier = %hu\015\012"
.LC11:
	.asciz	"(t)icks per servo cycle= %hu\015\012"
	.section	.text,code
	.align	2
	.global	_print_tuning	; export
_print_tuning:
	.set ___PA___,1
	lnk	#0
	mov	#.LC0,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	push	_pid+84
	mov	#.LC1,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#4,w15
	mov	_pid+56,w0
	mov	_pid+56+2,w1
	mov.d	w0,[w15++]
	mov	#.LC2,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+60,w0
	mov	_pid+60+2,w1
	mov.d	w0,[w15++]
	mov	#.LC3,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+64,w0
	mov	_pid+64+2,w1
	mov.d	w0,[w15++]
	mov	#.LC4,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+68,w0
	mov	_pid+68+2,w1
	mov.d	w0,[w15++]
	mov	#.LC5,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+72,w0
	mov	_pid+72+2,w1
	mov.d	w0,[w15++]
	mov	#.LC6,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+12,w0
	mov	_pid+12+2,w1
	mov.d	w0,[w15++]
	mov	#.LC7,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+76,w0
	mov	_pid+76+2,w1
	mov.d	w0,[w15++]
	mov	#.LC8,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+16,w0
	mov	_pid+16+2,w1
	mov.d	w0,[w15++]
	mov	#.LC9,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	push	_pid+88
	mov	#.LC10,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#4,w15
	push	_pid+90
	mov	#.LC11,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#4,w15
	ulnk	
	return	
	.set ___PA___,0
	.section	.const,psv
.LC12:
	.asciz	"\015encoder = 0x%04X = %d\015\012"
.LC13:
	.asciz	"\015Servo Loop Internal Calcs:\015\012"
.LC14:
	.asciz	"command: %ld\015\012"
.LC15:
	.asciz	"feedback: %ld\015\012"
.LC16:
	.asciz	"error: %f\015\012"
.LC17:
	.asciz	"error_i: %f\015\012"
.LC18:
	.asciz	"error_d: %f\015\012"
.LC19:
	.asciz	"output: %f\015\012"
.LC20:
	.asciz	"limit_state: %d\015\012"
.LC21:
	.asciz	"\015\012USAGE:\015\012"
.LC22:
	.asciz	"p x.x set proportional gain\015\012"
.LC23:
	.asciz	"i x.x set integral gain\015\012"
.LC24:
	.asciz	"d x.x set differential gain\015\012"
.LC25:
	.asciz	"0 x.x set FF0 gain\015\012"
.LC26:
	.asciz	"1 x.x set FF1 gain\015\012"
.LC27:
	.asciz	"b x.x set deadband\015\012"
.LC28:
	.asciz	"m x.x set max output current(amps)\015\012"
.LC29:
	.asciz	"f x.x set max error before drive faults(counts)\015\012"
.LC30:
	.asciz	"x n   set pc command multiplier (1-16)\015\012"
.LC31:
	.asciz	"t n   set # of 100us ticks/per servo calc(2-100)\015\012"
.LC32:
	.asciz	"e print current encoder count\015\012"
.LC33:
	.asciz	"l print current loop tuning values\015\012"
.LC34:
	.asciz	"s print internal loop components\015\012"
.LC35:
	.asciz	"? print this help\015\012"
	.section	.text,code
	.align	2
	.global	_process_serial_buffer	; export
_process_serial_buffer:
	.set ___PA___,1
	lnk	#4
	mov.b	_rxbuff,WREG
	se	w0,w2
	asr	w2,#15,w3
	mov	#65488,w0
	mov	#-1,w1
	add	w0,w2,w2
	addc	w1,w3,w3
	mov.d	w2,[w14]
	mov	#72,w0
	mov	#0,w1
	mov.d	[w14],w2
	sub	w2,w0,[w15]
	subb	w3,w1,[w15]
	.set ___BP___,0
	bra	gtu,.L31
	mov.d	[w14],w0
	bra	w0
	.align	2
	.set	___PA___,0
.L32:
	bra	.L12
	bra	.L14
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L4
	bra	.L31
	bra	.L10
	bra	.L28
	bra	.L18
	bra	.L31
	bra	.L31
	bra	.L8
	bra	.L31
	bra	.L31
	bra	.L29
	bra	.L16
	bra	.L31
	bra	.L31
	bra	.L6
	bra	.L31
	bra	.L31
	bra	.L30
	bra	.L24
	bra	.L31
	bra	.L31
	bra	.L31
	bra	.L20
	.set	___PA___,1
.L4:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L5
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	mov	w0,_pid+12
	mov	w1,_pid+12+2
	rcall	_save_setup
.L5:
	rcall	_print_tuning
	bra	.L3
.L6:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L7
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	mov	w0,_pid+56
	mov	w1,_pid+56+2
	rcall	_save_setup
.L7:
	rcall	_print_tuning
	bra	.L3
.L8:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L9
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	mov	w0,_pid+60
	mov	w1,_pid+60+2
	mul.uu	w0,#0,w0
		
	mov	w0,_pid+32
	mov	w1,_pid+32+2
	rcall	_save_setup
.L9:
	rcall	_print_tuning
	bra	.L3
.L10:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L11
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	mov	w0,_pid+64
	mov	w1,_pid+64+2
	rcall	_save_setup
.L11:
	rcall	_print_tuning
	bra	.L3
.L12:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L13
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	mov	w0,_pid+68
	mov	w1,_pid+68+2
	rcall	_save_setup
.L13:
	rcall	_print_tuning
	bra	.L3
.L14:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L15
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	mov	w0,_pid+72
	mov	w1,_pid+72+2
	rcall	_save_setup
.L15:
	rcall	_print_tuning
	bra	.L3
.L16:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L17
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	mov	w0,_pid+76
	mov	w1,_pid+76+2
	rcall	_save_setup
.L17:
	rcall	_print_tuning
	bra	.L3
.L18:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L19
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	mov	w0,_pid+16
	mov	w1,_pid+16+2
	rcall	_save_setup
.L19:
	rcall	_print_tuning
	bra	.L3
.L20:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L21
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	rcall	___fixsfsi
	mov	w0,_pid+88
	cp0	_pid+88
	.set ___BP___,0
	bra	gt,.L22
	mov	#1,w0
	mov	w0,_pid+88
.L22:
	mov	_pid+88,w0
	sub	w0,#16,[w15]
	.set ___BP___,0
	bra	le,.L23
	mov	#16,w0
	mov	w0,_pid+88
.L23:
	rcall	_save_setup
.L21:
	rcall	_print_tuning
	bra	.L3
.L24:
	cp0.b	_rxbuff+1
	.set ___BP___,0
	bra	z,.L25
	mul.uu	w2,#0,w2
	clr	w1
	mov	#_rxbuff+1,w0
	rcall	__Stof
	rcall	___fixsfsi
	mov	w0,_pid+90
	mov	_pid+90,w0
	sub	w0,#1,[w15]
	.set ___BP___,0
	bra	gt,.L26
	mov	#2,w0
	mov	w0,_pid+90
.L26:
	mov	_pid+90,w1
	mov	#100,w0
	sub	w1,w0,[w15]
	.set ___BP___,0
	bra	le,.L27
	mov	#100,w0
	mov	w0,_pid+90
.L27:
	rcall	_save_setup
.L25:
	rcall	_print_tuning
	bra	.L3
.L28:
	push	_POSCNT
	push	_POSCNT
	mov	#.LC12,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	bra	.L3
.L29:
	rcall	_print_tuning
	bra	.L3
.L30:
	mov	#.LC13,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	_pid,w2
	mov	_pid+2,w3
	mov.d	w2,[w15++]
	mov	#.LC14,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+4,w0
	mov	_pid+4+2,w1
	mov.d	w0,[w15++]
	mov	#.LC15,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+8,w2
	mov	_pid+8+2,w3
	mov.d	w2,[w15++]
	mov	#.LC16,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+32,w0
	mov	_pid+32+2,w1
	mov.d	w0,[w15++]
	mov	#.LC17,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+40,w2
	mov	_pid+40+2,w3
	mov.d	w2,[w15++]
	mov	#.LC18,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	mov	_pid+80,w0
	mov	_pid+80+2,w1
	mov.d	w0,[w15++]
	mov	#.LC19,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#6,w15
	push	_pid+86
	mov	#.LC20,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#4,w15
	bra	.L3
.L31:
	mov	#.LC21,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC22,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC23,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC24,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC25,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC26,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC27,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC28,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC29,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC30,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC31,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC32,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC33,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC34,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#.LC35,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
.L3:
	clr	w0
	mov	w0,_rxrdy
	clr.b	w0
	mov.b	WREG,_rxbuff
	mov	#_rxbuff,w0
	mov	w0,_rxbuffptr
	mov	__Files+2,w0
	mov	__Files+2,w1
	mov	[w0+8],w2
	mov	[w1+12],w0
	sub	w2,w0,[w15]
	.set ___BP___,0
	bra	geu,.L33
	mov	__Files+2,w0
	add	w0,#8,w3
	mov	[w3],w0
	mov	w0,w2
	mov.b	#62,w1
	mov.b	w1,[w2]
	inc	w0,w0
	mov	w0,[w3]
	bra	.L2
.L33:
	mov	__Files+2,w1
	mov	#62,w0
	rcall	_fputc
.L2:
	ulnk	
	return	
	.set ___PA___,0

	.end
