	.file "c:\\Projects\\private\\cnc_serwo\\example\\test.c"
	.section	.const,psv
.LC0:
	.asciz	"Testing current ramps via pwm and OPA549\015\012"
	.section	.text,code
	.align	2
	.global	_test_pwm_interface	; export
_test_pwm_interface:
	.set ___PA___,1
	lnk	#14
	mov	#0,w0
	mov	#16576,w1
	mov.d	w0,[w14]
	mov	#52429,w0
	mov	#15692,w1
	mov	w0,[w14+8]
	mov	w1,[w14+10]
	mov	#10,w0
	mov	w0,[w14+12]
	mov	#.LC0,w0
	mov	w0,[w15++]
	rcall	__iprintf
	dec2	w15,w15
	mov	[w14+12],w0
	mov	w0,_timer_test
.L2:
	mov.d	[w14],w0
	btg	w1,#15
	mov	w0,[w14+4]
	mov	w1,[w14+6]
.L5:
	mov.d	[w14],w2
	mov	[w14+4],w0
	mov	[w14+6],w1
	rcall	___lesf2
	cp0	w0
	.set ___BP___,0
	bra	gt,.L6
	mov	[w14+4],w0
	mov	[w14+6],w1
	rcall	_set_pwm
.L9:
	cp0	_timer_test
	.set ___BP___,0
	bra	nz,.L9
	mov	[w14+12],w1
	mov	w1,_timer_test
	mov	[w14+8],w2
	mov	[w14+10],w3
	mov	[w14+4],w0
	mov	[w14+6],w1
	rcall	___addsf3
	mov	w0,[w14+4]
	mov	w1,[w14+6]
	bra	.L5
.L6:
	mov.d	[w14],w0
	mov	w0,[w14+4]
	mov	w1,[w14+6]
.L12:
	mov.d	[w14],w0
	mov.d	w0,w2
	btg	w3,#15
	mov	[w14+4],w0
	mov	[w14+6],w1
	rcall	___gesf2
	cp0	w0
	.set ___BP___,0
	bra	lt,.L2
	mov	[w14+4],w0
	mov	[w14+6],w1
	rcall	_set_pwm
.L16:
	cp0	_timer_test
	.set ___BP___,0
	bra	nz,.L16
	mov	[w14+12],w1
	mov	w1,_timer_test
	mov	[w14+8],w2
	mov	[w14+10],w3
	mov	[w14+4],w0
	mov	[w14+6],w1
	rcall	___subsf3
	mov	w0,[w14+4]
	mov	w1,[w14+6]
	bra	.L12
	.section	.const,psv
.LC1:
	.asciz	"Testing pc command interface on IC1 and IC2\015\012"
.LC2:
	.asciz	"cmd = 0x%04X, err = 0x%04X, bits= 0x%02X\015\012"
	.section	.text,code
	.align	2
	.global	_test_pc_interface	; export
_test_pc_interface:
	.set ___PA___,1
	lnk	#0
	mov	#.LC1,w0
	mov	w0,[w15++]
	rcall	__iprintf
	dec2	w15,w15
	mov	#10000,w0
	mov	w0,_timer_test
.L23:
	cp0	_timer_test
	.set ___BP___,0
	bra	nz,.L23
	mov	#10000,w0
	mov	w0,_timer_test
	push	_cmd_bits
	push	_cmd_err
	push	_cmd_posn
	mov	#.LC2,w0
	mov	w0,[w15++]
	rcall	__iprintf
	sub	w15,#8,w15
	mov.b	_LATEbits,WREG
	ze	w0,w0
	lsr	w0,w0
	ze	w0,w0
	and	w0,#1,w0
	cp0	w0
	.set ___BP___,0
	bra	z,.L26
	bclr.b	_LATEbits,#1
	bra	.L23
.L26:
	bset.b	_LATEbits,#1
	bra	.L23
	.section	.const,psv
.LC3:
	.asciz	"Testing pid loop operation\015\012"
.LC4:
	.asciz	"cmd = %6.0f, feedback = %6.0f err = %6.0f, output = %6.0f\015\012"
	.section	.text,code
	.align	2
	.global	_test_pid_interface	; export
_test_pid_interface:
	.set ___PA___,1
	lnk	#0
	mov	#.LC3,w0
	mov	w0,[w15++]
	rcall	_printf
	dec2	w15,w15
	mov	#10000,w0
	mov	w0,_timer_test
.L29:
	cp0	_do_servo
	.set ___BP___,0
	bra	z,.L32
	clr	w0
	mov	w0,_do_servo
	mov	_cmd_posn,w0
	asr	w0,#15,w1
	rcall	___floatsisf
	rcall	___fixsfsi
	mov	w0,_pid
	mov	w1,_pid+2
	mov	_POSCNT,w0
	asr	w0,#15,w1
	rcall	___floatsisf
	rcall	___fixsfsi
	mov	w0,_pid+4
	mov	w1,_pid+4+2
	rcall	_calc_pid
	mul.uu	w2,#0,w2
		
	mov	_pid+80,w0
	mov	_pid+80+2,w1
	rcall	___gtsf2
	cp0	w0
	.set ___BP___,0
	bra	le,.L33
	bset.b	_LATEbits,#2
	bra	.L35
.L33:
	bclr.b	_LATEbits,#2
.L35:
	mov	_pid+80,w0
	mov	_pid+80+2,w1
	bclr	w1,#15
	rcall	_set_pwm
.L32:
	cp0	_timer_test
	.set ___BP___,0
	bra	nz,.L29
	mov	#10000,w0
	mov	w0,_timer_test
	mov	_pid+80,w0
	mov	_pid+80+2,w1
	mov.d	w0,[w15++]
	mov	_pid+8,w0
	mov	_pid+8+2,w1
	mov.d	w0,[w15++]
	mov	_pid+4,w0
	mov	_pid+4+2,w1
	rcall	___floatsisf
	mov.d	w0,[w15++]
	mov	_pid,w0
	mov	_pid+2,w1
	rcall	___floatsisf
	mov.d	w0,[w15++]
	mov	#.LC4,w0
	mov	w0,[w15++]
	rcall	_printf
	sub	w15,#18,w15
	mov.b	_LATEbits,WREG
	ze	w0,w0
	lsr	w0,w0
	ze	w0,w0
	and	w0,#1,w0
	cp0	w0
	.set ___BP___,0
	bra	z,.L37
	bclr.b	_LATEbits,#1
	bra	.L29
.L37:
	bset.b	_LATEbits,#1
	bra	.L29

	.end
